//************************************************************************************
//**  
//**  File name:     E:\PIC\AVR\32_int.c
//**  Generated by:  Flowcode v4.3.9.65
//**  Date:          Sunday, September 02, 2012 14:32:10
//**  Licence:       Free version
//**  
//**        ***For users exUSSR ***
//**  
//**  
//**     NOT FOR COMMERCIAL USE
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//Defines for microcontroller
#define MX_AVR
#define MX_EE
#define MX_EE_SIZE 1024
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 6
#define MX_SPI_SDO 5
#define MX_SPI_SCK 7
#define MX_UART
#define MX_UART_D
#define MX_UART_TX 1
#define MX_UART_RX 0
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 1
#define MX_I2C_SCL 0
#define MX_PWM
#define MX_PWM_PORT PORTD
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRD
#define MX_PWM_1 5
#define MX_PWM_TRIS2 DDRD
#define MX_PWM_2 4
#define MX_PWMTYPE 1

//Functions
#define F_CPU 10000000UL
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <avr\wdt.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

//Configuration data
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode AVR V4\FCD\internals.h"

//Macro function declarations
void FCM_COMP();
void FCM_INT();


//Variable declarations



//Macro implementations

void FCM_COMP()
{
	
	//Output
	//Output: 1 -> A7
	DDRA = DDRA | 0x80;
	if (1)
		PORTA = (PORTA & 0x7f) | 0x80;
	else
		PORTA = PORTA & 0x7f;


	//C Code
	//C Code:
	TCCR1B &= 0xf8;
	TCNT1=0;



	//Delay
	//Delay: 10 us
	delay_us(10);


	//Output
	//Output: 0 -> A7
	DDRA = DDRA | 0x80;
	if (0)
		PORTA = (PORTA & 0x7f) | 0x80;
	else
		PORTA = PORTA & 0x7f;


}

void FCM_INT()
{
	
	//Output
	//Output: 1 -> A0
	DDRA = DDRA | 0x01;
	if (1)
		PORTA = (PORTA & 0xfe) | 0x01;
	else
		PORTA = PORTA & 0xfe;


	//C Code
	//C Code:
	//Interrupt: Enable TCNT1_A
		TCCR1B |= 0x03;


	//Output
	//Output: 0 -> A0
	DDRA = DDRA | 0x01;
	if (0)
		PORTA = (PORTA & 0xfe) | 0x01;
	else
		PORTA = PORTA & 0xfe;


}

int main()
{
	
	//Initialisation
	MCUCSR=0x00;
	wdt_disable();


	//Interrupt initialisation code
	
	//Interrupt
	//Interrupt: Enable INT0
	MCUCR |= (1 << ISC01) | (1 << ISC00);
	sei();
	GICR |= (1 << INT0);


	//Interrupt
	//Interrupt: Enable TCNT1_A
	TCCR1B &= 0xf8;
	TCCR1A &= 0x3F;
	OCR1A=2048-1;
	sei();
	TIMSK |= (1 << OCIE1A);
	TCCR1B &= 0xF7;
	TCCR1B |= (1<<WGM12);


	mainendloop: goto mainendloop;
}

	//Handler code for [INT0]
	#ifndef MX_INT0_HANDLER
	#define MX_INT0_HANDLER
	ISR(INT0_vect)
	{
		FCM_INT();
	}
	#else
	#warning The <INT0 Input> interrupt has previously been enabled, so the macro <INT> may never get called.
	#endif


	//Handler code for [TCNT1_A]
	#ifndef MX_TIMER1COMPA_HANDLER
	#define MX_TIMER1COMPA_HANDLER
	ISR(TIMER1_COMPA_vect)
	{
		FCM_COMP();
	}
	#else
	#warning The <TIMER1 COMPA> interrupt has previously been enabled, so the macro <COMP> may never get called.
	#endif




